"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.precompile04 = void 0;
const evm_1 = require("../evm");
const util_1 = require("@ethereumjs/util");
function precompile04(opts) {
    if ((0, util_1.isFalsy)(opts.data))
        throw new Error('opts.data missing but required');
    const data = opts.data;
    let gasUsed = opts._common.param('gasPrices', 'identity');
    gasUsed += opts._common.param('gasPrices', 'identityWord') * BigInt(Math.ceil(data.length / 32));
    if (opts.gasLimit < gasUsed) {
        return (0, evm_1.OOGResult)(opts.gasLimit);
    }
    return {
        executionGasUsed: gasUsed,
        returnValue: data,
    };
}
exports.precompile04 = precompile04;
//# sourceMappingURL=04-identity.js.map